(defun c:mesacabeceira () ; esta linha define a função "mesa de cabeceira", que cria uma mesa de cabeceira conforme as indicações desejadas

(setq pontos2d (getvar "osmode"))
(setq pontos3d (getvar "3dosmode")) 
(setvar "osmode" 0)
(setvar "3dosmode" 0) ; este parágrafo altera as definições de visualização do Autocad para um 2D simples

(setq pt1 (getpoint "insira o ponto de inserção: ")) ; é pedido ao utilizador que defina o ponto de inserção da mesa de cabeceira

(If (= nil
(setq comprimento (getreal "indique o comprimento:")))
(setq comprimento 0.60)) ; é de seguida pedido ao utilizador que indique o comprimento da mesa de cabeceira, e se não for fornecido uma resposta, o comprimento será o comprimento predefinido de 0,6metros

(If (= nil
(setq largura (getreal "indique a largura: ")))
(setq largura 0.60)) ; o mesmo acontece com a largura, é pedido ao utilizador que indique a largura da mesa de cabeceira, mas caso esta nao seja fornecida, a largura irá corresponder a 0,6 metros

(If (= nil
(setq altura (getreal "indique a altura do tampo: ")))
(setq altura 0.50)) ; é pedido também ao utilizador que indique a altura a que estará o tampo da mesa de cabeceira, tendo já uma altura predefinida de 0,5 metros 

(If (= nil
(setq espessura (getreal "indique a espessura do tampo: ")))
(setq espessura 0.05)) ; tambem e pedido para que se indique a espessura do tampo, e caso nenhuma seja fronecida, a espessura será 0.05metros

(If (= nil
(setq altgav (getreal "indique a distacia da gaveta: ")))
(setq altgav 0.20)) ; agora para definir a gaveta, e pedido ao utilizador que defina a que altura esta estará, tendo uma altura ja predefinida de 0,20metros 

(If (= nil
(setq alturapes (getreal "indique a altura dos pés do movel: ")))
(setq alturapes 0.10))

(If (= nil
(setq esppes (getreal "tamanho dos pes do movel: ")))
(setq esppes 0.05)) ; por fim, é pedido ao utilizador que defina o tamanho dos pés da mesa de cabeceira

(modelar)
(setvar "osmode" pontos2d)
(setvar "3dosmode" pontos3d) ; este paragrafo restabelece as definições de vizualisação do Autocad

(command "ucs" "") ; é utilizado este comando para se restabelecer o UCS ao plano horizontal
(command "shade") ; o comando é usado para alterar o visual style para shaded
)

(defun modelar () ; é definida a funçao modelar que vai entao criar então a mesa de cabeceira

(command "ucs" pt1 "") ; este comando define como ponto de origem o ponto de inserção previamente indicado

(command "rectang" (list 0 0 alturapes) "d" comprimento largura (list comprimento largura))
(command "extrude" (entlast) "" espessura)
(setq bbaixo (entlast)) ; através da criação de um retângulo e depois do seu extrude, é criada a base da mesa de cabeceira, que será guardada como "bbaixo"

(command "rectang" (list 0 0 (+ alturapes espessura)) "d" espessura largura (list espessura largura))
(command "extrude" (entlast) "" altura)
(setq lesq (entlast)) ; através da criação de um retângulo e depois do seu extrude, é criada a trave lateral esquerda da mesa de cabeceira, guardada como "lesq"

(command "rectang" (list comprimento 0 (+ alturapes espessura)) "d" (- espessura) largura (list (- espessura) largura))
(command "extrude" (entlast) "" altura)
(setq ldrt (entlast)) ; através da criação de um retângulo e depois do seu extrude, é agora criada a trave lateral direita da mesa de cabeceira, guardada como "ldrt"

(command "rectang" (list 0 0  (+ altura alturapes espessura)) "d" comprimento largura (list comprimento largura))
(command "offset" "e" "y" 0.05 (entlast) (list (+ comprimento comprimento) (+ largura largura)) "")
(command "extrude" (entlast) "" espessura)
(setq bcima (entlast)) ; através da criação de um retângulo e da aplicação de um offset de 0.05 segue-se depois o seu extrude, e é criado desta vez o tampo superior da mesa de cabeceira, guardada como "bcima"

(command "rectang" (list 0 0 alturapes) "d" comprimento espessura (list comprimento espessura))
(command "extrude" (entlast) "" altura)
(setq ts (entlast)) 

(command "rectang" (list 0 0 (+ alturapes altgav)) "d" comprimento largura (list comprimento largura))
(command "extrude" (entlast) "" espessura)
(setq bmeio (entlast)) ; através da criação de um retângulo e depois do seu extrude, é criada a prateleira da mesa de cabeceira, guardada como "bmeio" 

(command "rectang" (list 0 0 0) "d" esppes esppes (list esppes esppes))
(command "extrude" (entlast) "" alturapes)
(setq pe1 (entlast)) ; através da criação de um retângulo e depois do seu extrude, é criado o primeiro pé da nossa mesa de cabeceira,guardado como "pe1"

(command "rectang" (list comprimento 0 0) "d" (- esppes) esppes (list (- esppes) esppes))
(command "extrude" (entlast) "" alturapes)
(setq pe2 (entlast))
(command "rectang" (list comprimento largura 0) "d" (- esppes) (- esppes) (list (- esppes) (- esppes)))
(command "extrude" (entlast) "" alturapes)
(setq pe3 (entlast))
(command "rectang" (list 0 largura 0) "d" esppes (- esppes) (list esppes (- esppes)))
(command "extrude" (entlast) "" alturapes)
(setq pe4 (entlast)) ; por fim são criados os restantes pés da mesa de cabeceira, através da criação de um retângulo e depois do seu extrude

(command "union" bbaixo ldrt lesq bcima ts bmeio pe1 pe2 pe3 pe4 "") ; este comando por fim é usado para unir todos os elementos da mesa de cabeceira ,criados previamente 
)